<?php
/* * 
 * 功能：彩虹易支付页面跳转同步通知页面
 * 版本：3.3
 * 日期：2012-07-23
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究支付宝接口使用，只是提供一个参考。

 *************************页面功能说明*************************
 * 该页面可在本机电脑测试
 * 可放入HTML等美化页面的代码、商户业务逻辑程序代码
 * 该页面可以使用PHP开发工具调试，也可以使用写文本函数logResult，该函数已被默认关闭，见alipay_notify_class.php中的函数verifyReturn
 */

require_once("./inc.php");
require_once(SYSTEM_ROOT."epay/epay.config.php");
require_once(SYSTEM_ROOT."epay/epay_notify.class.php");
require_once("../conf.php");

//计算得出通知验证结果
$alipayNotify = new AlipayNotify($alipay_config);
$verify_result = $alipayNotify->verifyReturn();
if($verify_result) {
	//商户订单号

	$out_trade_no = daddslashes($_GET['out_trade_no']);

	//支付宝交易号

	$trade_no = $_GET['trade_no'];

	//交易状态
	$trade_status = $_GET['trade_status'];

	//金额
	$money = $_GET['money'];

	$srow=$DB->get_row("SELECT * FROM ds_pay WHERE trade_no='{$out_trade_no}' limit 1 for update");

    if($_GET['trade_status'] == 'TRADE_FINISHED' || $_GET['trade_status'] == 'TRADE_SUCCESS') {
		if($srow['status']==0 && $srow['money']==$money){
			$DB->query("update `ds_pay` set `status` ='1' where `trade_no`='{$out_trade_no}'");
			if($DB->affected()>=1){
				$DB->query("update `ds_pay` set `endtime` ='$date' where `trade_no`='{$out_trade_no}'");
				if (is_array(json_decode($srow['input'],true)) && $srow['num'] == 0) {
					$res = json_decode($srow['input'],true);
					if ($res['type'] == 'wxpay') {
						$res['type'] = 3;
					}
					if ($res['type'] == 'alipay') {
						$res['type'] = 1;
					}
					if ($res['type'] == 'qqpay') {
						$res['type'] = 2;
					}
					$param = [
					    'api_id'=>trim($transfer_conf['transfer_id']),
					    'money'=>$res['money'],
					    'payee_type'=>$res['type'],
					    'payee_account'=>$res['account'],
						'payee_name'=>$res['name'],
						'realname'=>$transfer_conf['transfer_check'],
						'timestamp'=>time(),
						'pay_pass'=>md5($transfer_conf["transfer_pass"]),
					];
					$param['sign'] = getSign($param, trim($transfer_conf['transfer_key']));
					$ch = curl_init();
					curl_setopt($ch,CURLOPT_URL,'http://www.dmf.cn/pay.php');
					curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
					curl_setopt($ch,CURLOPT_HEADER,0);
					curl_setopt($ch,CURLOPT_CONNECTTIMEOUT , 10);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
					curl_setopt($ch,CURLOPT_TIMEOUT, 10);
					curl_setopt($ch,CURLOPT_POST, 1);
					curl_setopt($ch,CURLOPT_POSTFIELDS, $param);
					$data = curl_exec($ch);
					curl_close($ch);
				}else{
					processOrder($srow);
				}
			}
			showalert('换钱成功，请查收！',1,$out_trade_no,$srow['tid']);
		}else{
			showalert('换钱成功，请查收！',1,$out_trade_no,$srow['tid']);
		}
    }
    else {
      echo "trade_status=".$_GET['trade_status'];
    }
}
else {
    //验证失败
	showalert('验证失败！',4,'shop');
}
function getSign($param, $key)
{
    $signPars = "";
    ksort($param);
    foreach ($param as $k => $v) {
        if ("sign" != $k && "" != $v) {
            $signPars .= $k . "=" . $v . "&";
        }
    }
    $signPars = trim($signPars, '&');
    $signPars .= $key;
    $sign = md5($signPars);
    return $sign;
}
?>